VERSION 5.00
Begin VB.Form Form2 
   BorderStyle     =   3  'Fixed Dialog
   Caption         =   "Subclassed Form"
   ClientHeight    =   990
   ClientLeft      =   45
   ClientTop       =   330
   ClientWidth     =   4680
   LinkTopic       =   "Form2"
   MaxButton       =   0   'False
   MinButton       =   0   'False
   ScaleHeight     =   990
   ScaleWidth      =   4680
   ShowInTaskbar   =   0   'False
   StartUpPosition =   3  'Windows Default
   WhatsThisButton =   -1  'True
   WhatsThisHelp   =   -1  'True
   Begin VB.CommandButton Command1 
      Caption         =   "&Click Here Next"
      Height          =   495
      Left            =   1080
      TabIndex        =   0
      Tag             =   "20010"
      Top             =   240
      Width           =   2175
   End
End
Attribute VB_Name = "Form2"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Option Explicit

Private hHelp As New HTMLHelp

Private Sub Command1_Click()
  
  ' Show the non-subclassed form
  Form1.Show
  Unload Me
  
End Sub

Public Sub OnHelp(hWndControl As Long)

  On Error GoTo ErrHandler
  
  Dim frmCurrent As Form
  Dim ctlControl As Control
  Dim errNumber As Integer
  Dim strCustom As String
  
  For Each frmCurrent In Forms
    For Each ctlControl In frmCurrent.Controls
      If (ctlControl.hwnd = hWndControl) Then
        With hHelp
          
          ' Set the popup type to CHM-based
          .HHPopupType = HH_CHM_POPUP
          
          ' Specify the CHM file and the internal
          ' text popup file
          .CHMFile = .HHSetHelpFile(1)
          .HHPopupFile = .HHSetHelpFile(2)
          
          ' Set the colors and text to match those
          ' from a HH_TP_HELP_WM_HELP popup
          .HHPopupCustomColors = True
          .HHPopupCustomBackColor = &HFFFF
          .HHPopupCustomTextColor = &HFFFF
          .HHPopupTextSize = "8"
          
          ' Get the context integer from the Tag property
          .HHPopupID = CLng(ctlControl.Tag)
          
          ' If the control has a Tag property, we're ok
          If errNumber <> 438 Then
            ' Tag property is empty
            
            If ctlControl.Tag = "" Then
              ' No topic ID is specified in the Tag property,
              ' so send up a generic message in order to
              ' prevent HH error message.
              strCustom = "HHSubclass message:" & _
                  Chr(10) & _
                  "You need to yell at the Help author for " & _
                  "not creating a Help topic for this item!"
              .HHPopupText = strCustom
              .HHPopupType = HH_TEXT_POPUP
              .HHDisplayPopup Me.hwnd
            
            Else
              ' Display the specified CHM-based popup topic
              .HHDisplayPopup Me.hwnd
              errNumber = 0
            End If
            
          ' If the control doesn't have a Tag property,
          ' deal with it.
          Else
            errNumber = 0
          End If
          
        End With
      End If
      
    Next ctlControl
  Next frmCurrent
  
  Exit Sub

ErrHandler:

  Select Case Err.Number
  Case 438
    ' The control being checked doesn't have a
    ' Tag property, so set the variable to Err.Number
    ' before it gets cleared
    errNumber = Err.Number
    Resume Next
    
  Case Else
    ' Nothing else to really be concerned with
    Resume Next
    
  End Select
  
End Sub

Private Sub Form_Load()
  
  HHSubclass Me
  
End Sub

Private Sub Form_Unload(Cancel As Integer)
  
  HHUnSubClass Me
  
End Sub
